- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files
- Directories
- Examples

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Protected Attributes

# CurveBase Class Reference

This reference page is linked to from the following overview topics: Mudbox 2013.

Search for all occurrences

## Detailed Description

Base class for Curve types.

Definition at line 20 of file curve.h.

`#include <curve.h>`

Inheritance diagram for CurveBase:
[legend]

List of all members.

## Public Member Functions
| CurveBase ()
| Constructor, initializes internal variables.
virtual | ~CurveBase ()
| Virtual destructor.
virtual void | Render ()
| Virtual render method.
virtual void | Serialize (Stream &s)
| Serialize the node.
void | SetSelected (bool bTOrF)
| Set and get selection state.
bool | Selected ()
virtual void | SetClosed (bool bTOrF)
| Creates a loop.
bool | Closed ()
virtual void | SetGeometry (mudbox::Geometry *pGeom)
| Set the mesh that this curve is associated with.
mudbox::Geometry * | Geometry () const
virtual const AxisAlignedBoundingBox & | BoundingBox ()
| Return world space bounding box.
virtual void | CopyTo (Node *pNode) const
| Copies this nodes data into passed in node.
virtual float | Length () const
| Returns length of curve in curve's coordinate system.
## Protected Attributes
abool | m_bSelected
abool | m_bClosed
aptr< mudbox::Geometry > | m_pGeometry
| Mesh that this curve is associated with. Can be NULL.
AxisAlignedBoundingBox | m_AABB
| 3D world space bounding box const AxisAlignedBoundingBox &,
bool | m_bRefreshBoundingBox

## Constructor & Destructor Documentation

CurveBase | ( |  | ) |

Constructor, initializes internal variables.

virtual ~CurveBase | ( |  | ) | `[virtual]`

Virtual destructor.

## Member Function Documentation

virtual void Render | ( |  | ) | `[virtual]`

Search for all occurrences

Virtual render method.

Reimplemented in NURBSCurve.

virtual void Serialize | ( | Stream & | s | ) | `[virtual]`

Search for all occurrences

Serialize the node.

Reimplemented from TreeNode.

Reimplemented in MudboxCurve, and NURBSCurve.

void SetSelected | ( | bool | bTOrF | ) | `[inline]`

Search for all occurrences

Set and get selection state.

Definition at line 38 of file curve.h.

    { m_bSelected = bTOrF; }

bool Selected | ( |  | ) | `[inline]`

Search for all occurrences

Definition at line 39 of file curve.h.

    { return m_bSelected; }

virtual void SetClosed | ( | bool | bTOrF | ) | `[inline, virtual]`

Search for all occurrences

Creates a loop.

Definition at line 42 of file curve.h.

    { m_bClosed = bTOrF; }

bool Closed | ( |  | ) | `[inline]`

Search for all occurrences

Definition at line 43 of file curve.h.

    { return m_bClosed; }

virtual void SetGeometry | ( | mudbox::Geometry * | pGeom | ) | `[virtual]`

Search for all occurrences

Set the mesh that this curve is associated with.

We had thought about doing parent child relationships where the Mesh was the parent and the Curve the child but for now we'll use pointer relationships.

mudbox::Geometry* Geometry | ( |  | ) | const

Search for all occurrences

virtual const AxisAlignedBoundingBox& BoundingBox | ( |  | ) | `[inline, virtual]`

Search for all occurrences

Return world space bounding box.

Reimplemented in MudboxCurve.

Definition at line 52 of file curve.h.

    { return m_AABB; }

virtual void CopyTo | ( | Node * | pNode | ) | const `[virtual]`

Search for all occurrences

Copies this nodes data into passed in node.

Reimplemented from TreeNode.

Reimplemented in MudboxCurve.

virtual float Length | ( |  | ) | const `[virtual]`

Search for all occurrences

Returns length of curve in curve's coordinate system.

If length is <0 then this function hasn't been implemented.

## Member Data Documentation

abool m_bSelected `[protected]`

Search for all occurrences

Definition at line 63 of file curve.h.

abool m_bClosed `[protected]`

Search for all occurrences

Reimplemented in NURBSCurve.

Definition at line 64 of file curve.h.

aptr<mudbox::Geometry> m_pGeometry `[protected]`

Search for all occurrences

Mesh that this curve is associated with. Can be NULL.

Definition at line 67 of file curve.h.

AxisAlignedBoundingBox m_AABB `[protected]`

Search for all occurrences

3D world space bounding box const AxisAlignedBoundingBox &,

Definition at line 72 of file curve.h.

bool m_bRefreshBoundingBox `[protected]`

Search for all occurrences

Definition at line 73 of file curve.h.

The documentation for this class was generated from the following file:

- Mudbox/curve.h

CurveBase CurveBase CurveBase CurveBase CurveBase CurveBase CurveBase CurveBase CurveBase CurveBase
CurveBase CurveBase CurveBase CurveBase CurveBase CurveBase CurveBase CurveBase CurveBase CurveBase